﻿@model Lifestoned.DataModel.Gdle.SandboxModel

@{
    ViewBag.Title = "Sandbox Submissions";
}

<br />

@if (Model?.Entries == null || Model.Entries.Count() < 1)
{
    <div class="alert alert-info">
        There are no changes to review.
    </div>
}
else
{
    <div class="text-right">
        <i class="glyphicon glyphicon-sort"></i>
        <select onchange="sortChanged(event)">
            <option value=""></option>
            <option value="id">Weenie Id</option>
            <option value="type">Item Type</option>
            <option value="name">Item Name</option>
            <option value="user">User Name</option>
            <option value="date">Submission Date</option>
        </select>
        @Html.ActionLink("Download", "Download", null, new { @class = "btn btn-sm btn-default" })
        @*@if (User.IsInRole("Admin"))
            {
                <button class="btn btn-sm btn-warning" type="button" onclick="approveAll(event)">Approve All</button>
            }*@
    </div>

    <div id="sandboxApp">

        @Html.DisplayFor(m => m.Entries, new { IsApproval = true })

        <lsd-spawn-map ref="mapDetails" :item="selectedMap" @@save="mapSaved"></lsd-spawn-map>

        <lsd-spell-table-entry ref="spellDetails" v-model="selectedSpell"></lsd-spell-table-entry>
    </div>

    @Html.Partial("CommentModal", new { source = "Sandbox" })
    @Html.Partial("SubmissionRejectModal")
}

@section scripts
{
    @Scripts.Render("~/ui/shared", "~/ui/spawns", "~/ui/spellTable")

    <script>
        Vue.use(AutoWatchMixin);
        Vue.use(SpellTableStore);
        var spellTableStore = makeSpellTableService();

        var spawnSearchApp = new Vue({
            el: '#sandboxApp',
            spellTableStore: spellTableStore,
            data: {
                selectedMap: null,
                selectedSpell: this.spellTableStore.newSpell()
            },

            methods: {
                editSpell(spellId) {
                    var $this = this;
                    this.$spellTable.fetch(spellId).then((spell) => {
                        $this.selectedSpell = spell;
                        $this.$refs.spellDetails.show();
                    });
                },

                editMap(mapId) {
                    var $i = this;
                    $.get('../Spawn/Map', { id: mapId }, function (data) {
                        $i.selectedMap = data;
                        $i.$refs.mapDetails.show();
                    });
                },

                mapSaved(item) {
                    $.post('Spawn/Save', { map: item }, function (data) {
                        console.log(data);
                    });
                }
            },
            mounted() {
            },
            destroyed() {
            }
        });

        function sortChanged(evt) {
            var prop = $(evt.target).val();
            var sortfn = (prop == "id" || prop == "type" || prop == "date") ?
                function (a, b) {
                    return (parseInt(a.dataset[prop]) > parseInt(b.dataset[prop])) ? 1 : -1;
                }
                :
                function (a, b) {
                    return (a.dataset[prop] > b.dataset[prop]) ? 1 : -1;
                };

            $(".well[data-id]").sort(sortfn).appendTo($(".entries"));
        }

    </script>

    @if (User.IsInRole("Developer"))
    {
        <script>
            $('.sandbox-approve').click(function (evt) {
                evt.preventDefault();
                evt.stopPropagation();

                var done = $(this).parent().find('checkbox').is(':checked');

                var i = this;
                $.post('../Sandbox/Accept',
                    { id: this.dataset.id, type: this.dataset.type, userId: this.dataset.user, done },
                    function () {
                        $(`.well[data-id='${i.dataset.id}']`).remove();
                    });
            });

        </script>
    }

    @*@if (User.IsInRole("Admin"))
        {
        <script>
            function approveAll(evt) {
                evt.preventDefault();
                evt.stopPropagation();

                $('input[approver]:checked').each(function (idx, item) {
                    var i = item;
                    $(`.well[data-id='${i.dataset.id}']`).addClass('disabled');
                    $.post('../Sandbox/Accept', {
                            id: item.dataset.id,
                            type: item.dataset.type,
                            userId: item.dataset.user,
                            0
                        },
                        function () {
                            $(`.well[data-id='${i.dataset.id}']`).remove();
                        });
                }).prop('checked', false);
            }
            $(function () { $('input[approver]').prop('checked', false); });
        </script>
        }*@

}
